VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsModbusTCP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private intComanda As Integer
Private strResposta As String
Private strHost As String
Private lngPort As Long

Private Const CMD_READ = 1
Private Const CMD_WRITE = 2

Public Property Get Host() As String
   Host = strHost
End Property
Public Property Let Host(Valor As String)
   strHost = Valor
End Property

Public Property Get Port() As Long
   Port = lngPort
End Property
Public Property Let Port(Valor As Long)
   lngPort = Valor
End Property

Public Function Inicialitzar(sckSocket As Winsock) As Boolean
Dim dblTemps As Double

   On Error GoTo TractaError
   'Miro si no esta tancat el socket
   If (sckSocket.State <> sckClosed) Then
      'Tanco el socket
      sckSocket.Close
   End If
   'Configuro el socket
   sckSocket.RemoteHost = strHost
   sckSocket.RemotePort = lngPort
   'Connecto el socket
   sckSocket.Connect
   'Timeout de 2 segons per establir connexio amb el PLC
   dblTemps = Timer
   Do While ((Timer < dblTemps + 2) And (sckSocket.State <> sckConnected))
      DoEvents
   Loop
   'Retorno true si he pogut connectar amb el PLC
   Inicialitzar = IIf(sckSocket.State = sckConnected, True, False)

Exit Function
TractaError:
   'Retorno false
   Inicialitzar = False
End Function

Public Function LlegirRegistrePLC(sckSocket As Winsock, strAdrRegistre As String, strRetorn As String, lngTamany As Long) As Boolean
Dim strComanda As String
Dim dblTemps As Double
Dim lngAdr As Long

   On Error GoTo TractaError
   'Miro si el socket esta connectat
   If sckSocket.State = sckConnected Then
      'Calculo l'adrea
      lngAdr = Val(strAdrRegistre)
      'Composo la comanda Modbus TCP/IP
      strComanda = Chr(0) + Chr(0) + Chr(0) + Chr(0) + Chr(0)
      strComanda = strComanda + Chr(6)
      strComanda = strComanda + Chr(1)
      strComanda = strComanda + Chr(3)
      strComanda = strComanda + Chr(lngAdr \ 256)
      strComanda = strComanda + Chr(lngAdr Mod 256)
      strComanda = strComanda + Chr(lngTamany \ 256)
      strComanda = strComanda + Chr(lngTamany Mod 256)
      'Em guardo la comanda per poder identificar la resposta
      intComanda = CMD_READ
      'Reset de la resposta
      strResposta = ""
      dblTemps = Timer
      'Envio la comanda
      sckSocket.SendData strComanda
      'Espero la resposta del PLC
      Do
         DoEvents
      Loop While strResposta = "" And Timer - dblTemps < 3
      'Miro si tinc resposta
      If strResposta <> "" Then
         'Capturo els valors de retorn
         strRetorn = Trim(strResposta)
         'Retorno true
         LlegirRegistrePLC = True
      End If
   Else
      'Reinicialitzo el socket
      If Inicialitzar(sckSocket) Then
         'Retorno true
         LlegirRegistrePLC = True
      End If
   End If
   
Exit Function
TractaError:
   'Retorno false
   LlegirRegistrePLC = False
End Function

Public Function EscriureRegistrePLC(sckSocket As Winsock, strAdrRegistre As String, lngValors() As Long, lngTamany As Long) As Boolean
Dim strComanda As String
Dim i As Integer
Dim lngAdr As Long
Dim dblTemps As Double

   On Error GoTo TractaError
   'Miro si el socket esta connectat
   If sckSocket.State = sckConnected Then
      'Calculo l'adrea
      lngAdr = Val(strAdrRegistre)
      'Composo la comanda Modbus TCP/IP
      strComanda = Chr(0) + Chr(0) + Chr(0) + Chr(0) + Chr(0)
      strComanda = strComanda + Chr((7 + 2 * lngTamany) Mod 256)
      strComanda = strComanda + Chr(1)
      strComanda = strComanda + Chr(16)
      strComanda = strComanda + Chr(lngAdr \ 256)
      strComanda = strComanda + Chr(lngAdr Mod 256)
      strComanda = strComanda + Chr(0)
      strComanda = strComanda + Chr(lngTamany)
      strComanda = strComanda + Chr(2 * lngTamany)
      For i = 0 To UBound(lngValors)
         strComanda = strComanda + Chr(lngValors(i) \ 256)
         strComanda = strComanda + Chr(lngValors(i) Mod 256)
      Next i
      'Em guardo la comanda per poder identificar la resposta
      intComanda = CMD_WRITE
      'Reset de la resposta
      strResposta = ""
      dblTemps = Timer
      'Envio la comanda
      sckSocket.SendData strComanda
      'Espero la resposta del PLC
      Do
         DoEvents
      Loop While strResposta = "" And Timer - dblTemps < 3
      'Retorno true
      EscriureRegistrePLC = True
   Else
      'Reinicialitzo el socket
      Inicialitzar sckSocket
   End If
   
Exit Function
TractaError:
   'Retorno false
   EscriureRegistrePLC = False
End Function

Public Function EscriureBitPLC(sckSocket As Winsock, strAdrRegistre As String, bolEstat As Boolean) As Boolean
Dim strComanda As String
Dim i As Integer
Dim lngAdr As Long

   On Error GoTo TractaError
   'Miro si el socket esta connectat
   If sckSocket.State = sckConnected Then
      'Calculo l'adrea
      lngAdr = Val(strAdrRegistre)
      'Composo la comanda Modbus TCP/IP
      strComanda = Chr(0) + Chr(0) + Chr(0) + Chr(0) + Chr(0)
      strComanda = strComanda + Chr(6)
      strComanda = strComanda + Chr(1)
      strComanda = strComanda + Chr(5)
      strComanda = strComanda + Chr(lngAdr \ 256)
      strComanda = strComanda + Chr(lngAdr Mod 256)
      If bolEstat Then
         strComanda = strComanda + Chr(255) + Chr(0)
      Else
         strComanda = strComanda + Chr(0) + Chr(0)
      End If
      'Em guardo la comanda per poder identificar la resposta
      intComanda = CMD_WRITE
      'Envio la comanda
      sckSocket.SendData strComanda
      'Retorno true
      EscriureBitPLC = True
   Else
      'Reinicialitzo el socket
      Inicialitzar sckSocket
   End If
   
Exit Function
TractaError:
   'Retorno false
   EscriureBitPLC = False
End Function

Public Sub TractarRespostaPLC(bytArray() As Byte)
Dim intLen As Integer
Dim i As Integer
Dim lngVal As Long

   On Error GoTo TractaError
   'Miro la ultima comanda realitzada
   Select Case intComanda
      
      'Lectura
      Case CMD_READ
         'Capturo el numero de valors que he rebut del PLC
         intLen = bytArray(9) + 9
         'Bucle per tots els valors
         For i = 10 To intLen Step 2
            'Capturo els valors
            lngVal = CLng(bytArray(i)) * 256
            lngVal = lngVal + bytArray(i + 1)
            strResposta = strResposta & Str(lngVal)
         Next i
         
      'Escriptura
      Case CMD_WRITE
         'Ignoro qualsevol resposta
         strResposta = "-"
   
   End Select
   
Exit Sub
TractaError:
   'Resposta erronia
   strResposta = ""
End Sub
